﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using FirebirdSql.Data.FirebirdClient;

namespace SkladEvidence
{
    /// <summary>
    /// Správa příjmů.
    /// Číslování chyb: 9000 - 9999.
    /// </summary>
    ///
    internal partial class Prijem : Form, IForm
    {
        bool bkonec = false;
        int pocet, mnozstviSkladem, i, index = 0;
        private Util util;
        int mezera = 30;
        int xz, yz, xm, ym, xo, yo, xc, yc, xp, yp, xs, ys, xh, yh;
        string prijem;
        System.Windows.Forms.ComboBox comboBox;
        System.Windows.Forms.NumericUpDown numericUpDown;
        System.Windows.Forms.TextBox textBox;
        System.Windows.Forms.Button button;

        public Prijem(Util pUtil)
        {
            InitializeComponent();
            this.util = pUtil;
        }

        public bool LzeUkoncit
        {
            get
            {
                return true;
            }
        }

        public bool Konec
        {
            set
            {
                bkonec = value;
            }
        }

        private void Prijem_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (e.Cancel = !this.bkonec)
                this.Hide();
        }

        private void Prijem_Load(object sender, EventArgs e)
        {
            this.NactiData();
        }

        private bool NactiData()
        {
            int iErrKod = 9000;
            FbCommand fbCmd = null;
            FbDataAdapter fbAda = null;
            string sErr, sPoleZbozi, sPoleDodavatel;
            int i1;

            try
            {
                if (!this.util.PripojDb(out fbCmd, out sErr))
                {
                    iErrKod = 9001;
                    this.util.PisLog("Příjem " + iErrKod.ToString() + ": " + sErr,
                      true);
                    return false;
                }

                fbCmd.Parameters.Clear();
                this.tabZbo.Clear();
                this.tabDod.Clear();
                this.cbZbozi0.Items.Clear();
                this.cbDodavatel.Items.Clear();

                sPoleZbozi = "ID, NAZEV, POPIS, CENA, MNOZSTVI ";
                sPoleDodavatel = "ID, NAZEV, ICO, DIC, PRIJMENI, JMENO, ULICE, " +
                  "MESTO, PSC, TELEFON, EMAIL, KDOZMENIL ";

                fbCmd.CommandText = "select " + sPoleZbozi + "from tzbozi order by nazev";

                fbAda = new FbDataAdapter(fbCmd);
                fbAda.Fill(this.tabZbo);

                for(i1 = 0; i1<this.tabZbo.Rows.Count; ++i1)
                {
                    this.cbZbozi0.Items.Add((string)this.tabZbo.Rows[i1]["nazev"]);
                }

                fbAda = null;
                fbCmd.CommandText = "";
                fbCmd.CommandText = "select " + sPoleDodavatel + "from tdodavatele order by nazev";
                fbAda = new FbDataAdapter(fbCmd);
                fbAda.Fill(this.tabDod);

                for (i1 = 0; i1 < this.tabDod.Rows.Count; ++i1)
                {
                    this.cbDodavatel.Items.Add((string)this.tabDod.Rows[i1]["nazev"]);
                }

                return true;
            }
            catch (Exception exc)
            {
                this.util.PisLog("Příjem " + iErrKod.ToString() + ": " +
                  exc.ToString(), true);

                return false;
            }
            finally
            {
                if (fbAda != null)
                    fbAda.Dispose();

                this.util.OdpojDb(fbCmd);
            }
        }

        private void btnPridej_Click(object sender, EventArgs e)
        {
            pocet += 1;
            int i1;
            xz = this.cbZbozi0.Location.X;
            yz = this.cbZbozi0.Location.Y;
            this.comboBox = new System.Windows.Forms.ComboBox();
            this.comboBox.Location = new System.Drawing.Point(xz, yz + (mezera * this.pocet));
            this.comboBox.Size = new System.Drawing.Size(this.cbZbozi0.Size.Width, this.cbZbozi0.Size.Height);
            this.comboBox.Name = "cbZbozi" + pocet.ToString();
            for (i1 = 0; i1 < this.tabZbo.Rows.Count; ++i1)
            {
                this.comboBox.Items.Add((string)this.tabZbo.Rows[i1]["nazev"]);
            }
            this.Controls.Add(this.comboBox);

            xm = this.nuMnozstvi0.Location.X;
            ym = this.nuMnozstvi0.Location.Y;
            this.numericUpDown = new System.Windows.Forms.NumericUpDown();
            this.numericUpDown.Location = new System.Drawing.Point(xm, ym + (mezera * this.pocet));
            this.numericUpDown.Size = new System.Drawing.Size(this.nuMnozstvi0.Size.Width, this.nuMnozstvi0.Size.Height);
            this.numericUpDown.Name = "nuMnozstvi" + pocet.ToString();
            this.Controls.Add(this.numericUpDown);

            xc = this.tbCena0.Location.X;
            yc = this.tbCena0.Location.Y;
            this.textBox = new System.Windows.Forms.TextBox();
            this.textBox.Location = new System.Drawing.Point(xc, yc + (mezera * this.pocet));
            this.textBox.Size = new System.Drawing.Size(this.tbCena0.Size.Width, this.tbCena0.Size.Height);
            this.textBox.Name = "tbCena" + pocet.ToString();
            this.Controls.Add(this.textBox);

            xp = this.btnPridej.Location.X;
            yp = this.btnPridej.Location.Y;
            this.btnPridej.Location = new Point(xp, yp + mezera);

            this.button = new System.Windows.Forms.Button();
            this.button.Location = new System.Drawing.Point(xp - 80, yp + mezera);
            this.button.Size = new System.Drawing.Size(this.btnPridej.Size.Width, this.btnPridej.Size.Height);
            this.button.Click += new EventHandler(this.btnZrusit_Click);
            this.button.BackColor = Color.LightGray;
            this.button.Text = "Zrušit";
            this.button.Name = "btnZrusit" + pocet.ToString();
            this.Controls.Add(this.button);

            xo = this.btnOK.Location.X;
            yo = this.btnOK.Location.Y;
            this.btnOK.Location = new Point(xo, yo + mezera);

            xs = this.btnStorno.Location.X;
            ys = this.btnStorno.Location.Y;
            this.btnStorno.Location = new Point(xs, ys + mezera);

            xh = this.btnHistorie.Location.X;
            yh = this.btnHistorie.Location.Y;
            this.btnHistorie.Location = new Point(xh, yh + mezera);
        }

        private void btnZrusit_Click(object sender, EventArgs e)
        {
            Button selectButton = (Button)sender;
            string cislo = Convert.ToString(selectButton.Name[9]);
            int cPocet = Convert.ToInt32(cislo);

            if (cPocet != this.pocet)
            {
               while (cPocet < this.pocet)
               {
                    int next = cPocet + 1;
                    this.Controls["tbCena" + cPocet].Text = this.Controls["tbCena" + next].Text.Trim();
                    this.Controls["nuMnozstvi" + cPocet].Text = this.Controls["nuMnozstvi" + next].Text.Trim();
                    this.Controls["cbZbozi" + cPocet].Text = this.Controls["cbZbozi" + next].Text.Trim();
                    cPocet++;
               }
            }

            this.Controls["tbCena" + this.pocet].Dispose();
            this.Controls["nuMnozstvi" + this.pocet].Dispose();
            this.Controls["cbZbozi" + this.pocet].Dispose();
            this.Controls["btnZrusit" + this.pocet].Dispose();
            xp = this.btnPridej.Location.X;
            yp = this.btnPridej.Location.Y;
            xo = this.btnOK.Location.X;
            yo = this.btnOK.Location.Y;
            xs = this.btnStorno.Location.X;
            ys = this.btnStorno.Location.Y;
            xh = this.btnHistorie.Location.X;
            yh = this.btnHistorie.Location.Y;

            this.button.Location = new Point(xp - 80, yp - mezera);
            this.btnPridej.Location = new Point(xp, yp - mezera);
            this.btnOK.Location = new Point(xo, yo - mezera);
            this.btnStorno.Location = new Point(xs, ys - mezera);
            this.btnHistorie.Location = new Point(xh, yh - mezera);
            this.pocet -= 1;
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            this.UlozData();
        }

        private void btnHistorie_Click(object sender, EventArgs e)
        {
            PrijemHistorie prijemHistorie = new PrijemHistorie(util);
            prijemHistorie.ShowDialog();
        }

        private bool UlozData()
        {
            int iErrKod = 9100;
            string sErr;
            int i1;
            FbCommand fbCmd = null;

            try
            {
                iErrKod = 9101;
                if (this.cbDodavatel.Text == "")
                {
                    this.util.PisLog("Dodavatel musí být zadán.", true);
                    this.cbDodavatel.Focus();
                    return false;
                }

                for (i1=0; i1<=pocet; i1++)
                {
                    if (this.Controls["cbZbozi" + i1].Text == "")
                    {
                        this.util.PisLog("zboží musí být zadáno.", true);
                        this.Controls["cbZbozi" + i1].Focus();
                        return false;
                    }

                    if (this.Controls["nuMnozstvi" + i1].Text == "")
                    {
                        this.util.PisLog("množství musí být zadáno.", true);
                        this.Controls["nuMnozstvi" + i1].Focus();
                        return false;
                    }

                    iErrKod = 9102;
                    if (!this.util.PripojDb(out fbCmd, out sErr))
                    {
                        iErrKod = 9103;
                        this.util.PisLog("Příjem " + iErrKod.ToString() + ": " + sErr,
                          true);
                        return false;
                    }

                    foreach(DataRow row in this.tabZbo.Rows)
                    {
                        if (row["nazev"].ToString() == this.Controls["cbZbozi" + i1].Text.Trim())
                            index = i;
                        i += 1;
                    }
                    mnozstviSkladem = Convert.ToInt32(this.tabZbo.Rows[index]["mnozstvi"]);

                    fbCmd.CommandText = "update tzbozi set MNOZSTVI = @mnozstvi, DODAVATEL = @dodavatel, KDOZMENIL = @kdozmenil where NAZEV = @nazev";
                    fbCmd.Parameters.Add("@mnozstvi", FbDbType.Integer).Value = this.mnozstviSkladem + Convert.ToInt32(this.Controls["nuMnozstvi" + i1].Text.Trim());
                    fbCmd.Parameters.Add("@dodavatel", FbDbType.VarChar, 30).Value = this.cbDodavatel.Text.Trim();
                    fbCmd.Parameters.Add("@kdozmenil", FbDbType.VarChar, 200).Value = this.util.KdoZmenil;
                    fbCmd.Parameters.Add("@nazev", FbDbType.VarChar, 100).Value = this.Controls["cbZbozi" + i1].Text.Trim();
                    fbCmd.ExecuteNonQuery();
                    fbCmd.Transaction.Commit();
                    fbCmd.CommandText = "";
                    fbCmd.Parameters.Clear();
                    fbCmd = null;
                    prijem += prijem = "Zboží: " + this.Controls["cbZbozi" + i1].Text.Trim() + " Množství: " + this.Controls["nuMnozstvi" + i1].Text.Trim() +
                            " Cena: " + this.Controls["tbCena" + i1].Text.Trim() + " | ";
                    this.mnozstviSkladem = 0;
                    this.i = 0;
                }

                iErrKod = 9200;
                if (!this.util.PripojDb(out fbCmd, out sErr))
                {
                    iErrKod = 9201;
                    this.util.PisLog("Příjem " + iErrKod.ToString() + ": " + sErr,
                      true);
                    return false;
                }

                fbCmd.CommandText = "insert into tprijem (DODAVATEL, PRIJEM, KDOZMENIL) values (@DODAVATEL, @PRIJEM, @KDOZMENIL)";
                fbCmd.Parameters.Add("@dodavatel", FbDbType.VarChar, 30).Value = this.cbDodavatel.Text.Trim();
                fbCmd.Parameters.Add("@kdozmenil", FbDbType.VarChar, 200).Value = this.util.KdoZmenil;
                fbCmd.Parameters.Add("@prijem", FbDbType.VarChar, 1000).Value = this.prijem;
                fbCmd.ExecuteNonQuery();
                fbCmd.Transaction.Commit();

                this.Obnov();
                NactiData();
                return true;
            }
            catch (Exception exc)
            {
                this.util.PisLog("Příjem " + iErrKod.ToString() + ". " +
                  exc.ToString(), true);
                return false;
            }
            finally
            {
                this.util.OdpojDb(fbCmd);
            }
        }

        private void Obnov()
        {
            int i1;
            for(i1=1; i1<=pocet; ++i1)
            {
                this.Controls["tbCena" + i1].Dispose();
                this.Controls["nuMnozstvi" + i1].Dispose();
                this.Controls["cbZbozi" + i1].Dispose();
                this.Controls["btnZrusit" + i1].Dispose();
            }
            this.btnOK.Location = new Point(29, 102);
            this.btnStorno.Location = new Point(121, 102);
            this.btnHistorie.Location = new Point(212, 102);
            this.btnPridej.Location = new Point(610, 43);
            this.cbDodavatel.Text = "";
            this.cbZbozi0.Text = "";
            this.nuMnozstvi0.ResetText();
            this.tbCena0.Text = "";
            this.pocet = 0;
            this.prijem = "";
        }

        private void btnStorno_Click(object sender, EventArgs e)
        {
            Obnov();
            NactiData();
        }
    }
}
