﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using FirebirdSql.Data.FirebirdClient;

namespace SkladEvidence
{
    internal partial class PrijemHistorie : Form
    {
        /// <summary>
        /// Správa příjmů, historie.
        /// Číslování chyb: 11000 - 11999.
        /// </summary>
        ///
        private Util util;

        public PrijemHistorie(Util util)
        {
            InitializeComponent();
            this.util = util;
            this.NactiData();
        }

        private bool NactiData()
        {
            int iErrKod = 11000;
            FbCommand fbCmd = null;
            FbDataAdapter fbAda = null;
            string sErr, sPole;

            this.prijem.Width = this.gr.ClientSize.Width - this.kdyzmenil.Width - this.dodavatel.Width - 25;

            try
            {

                if (!this.util.PripojDb(out fbCmd, out sErr))
                {
                    iErrKod = 11001;
                    this.util.PisLog("Příjem historie " + iErrKod.ToString() + ": " + sErr,
                      true);
                    return false;
                }

                this.tabpri.Clear();

                sPole = "KDYZMENIL, DODAVATEL, PRIJEM  ";

                iErrKod = 11002;
                fbCmd.CommandText = "select " + sPole + "from tprijem order by kdyzmenil";

                fbAda = new FbDataAdapter(fbCmd);
                fbAda.Fill(this.tabpri);

                return true;
            }
            catch (Exception exc)
            {
                this.util.PisLog("Příjem historie " + iErrKod.ToString() + ": " +
                  exc.ToString(), true);

                return false;
            }
            finally
            {
                if (fbAda != null)
                    fbAda.Dispose();

                this.util.OdpojDb(fbCmd);
            }
        }
    }
}
