﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using FirebirdSql.Data.FirebirdClient;

namespace SkladEvidence
{
    /// <summary>
    /// Správa výdejů.
    /// Číslování chyb: 10000 - 10999.
    /// </summary>
    ///
    internal partial class Vydej : Form, IForm
    {
        bool bkonec = false;
        private Util util;
        int pocet, mnozstviSkladem, i, index = 0;
        int mezera = 30;
        int xz, yz, xm, ym, xo, yo, xc, yc, xp, yp, xs, ys, xh, yh;
        string vydej;
        System.Windows.Forms.ComboBox comboBox;
        System.Windows.Forms.NumericUpDown numericUpDown;
        System.Windows.Forms.TextBox textBox;
        System.Windows.Forms.Button button;

        public Vydej(Util pUtil)
        {
            InitializeComponent();
            this.util = pUtil;
        }

        public bool LzeUkoncit
        {
            get
            {
                return true;
            }
        }

        public bool Konec
        {
            set
            {
                bkonec = value;
            }
        }

        private void Vydej_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (e.Cancel = !this.bkonec)
                this.Hide();
        }

        private void Vydej_Load(object sender, EventArgs e)
        {
            this.NactiData();
        }

        private bool NactiData()
        {
            int iErrKod = 10000;
            FbCommand fbCmd = null;
            FbDataAdapter fbAda = null;
            string sErr, sPoleZbozi, sPoleZakaznik;
            int i1;

            try
            {
                if (!this.util.PripojDb(out fbCmd, out sErr))
                {
                    iErrKod = 10001;
                    this.util.PisLog("Výdej " + iErrKod.ToString() + ": " + sErr,
                      true);
                    return false;
                }

                fbCmd.Parameters.Clear();
                this.tabZbo.Clear();
                this.tabZak.Clear();
                this.cbZakaznik.Items.Clear();
                this.cbZbozi0.Items.Clear();

                sPoleZbozi = "ID, NAZEV, POPIS, CENA, MNOZSTVI ";
                sPoleZakaznik = "ID, NAZEV, ICO, DIC, PRIJMENI, JMENO, ULICE, " +
                  "MESTO, PSC, TELEFON, EMAIL, KDOZMENIL ";

                fbCmd.CommandText = "select " + sPoleZbozi + "from tzbozi order by nazev";

                fbAda = new FbDataAdapter(fbCmd);
                fbAda.Fill(this.tabZbo);

                for (i1 = 0; i1 < this.tabZbo.Rows.Count; ++i1)
                {
                    this.cbZbozi0.Items.Add((string)this.tabZbo.Rows[i1]["nazev"]);
                }

                fbAda = null;
                fbCmd.CommandText = "";
                if(chbFirma.Checked)
                {
                    fbCmd.CommandText = "select " + sPoleZakaznik + "from tzakaznici where osoba = 'P' order by nazev";
                    fbAda = new FbDataAdapter(fbCmd);
                    fbAda.Fill(this.tabZak);
                    for (i1 = 0; i1 < this.tabZak.Rows.Count; ++i1)
                    {
                        this.cbZakaznik.Items.Add((string)this.tabZak.Rows[i1]["nazev"]);
                    }
                }

                else
                {
                    fbCmd.CommandText = "select " + sPoleZakaznik + "from tzakaznici where osoba = 'F' order by prijmeni";
                    fbAda = new FbDataAdapter(fbCmd);
                    fbAda.Fill(this.tabZak);
                    for (i1 = 0; i1 < this.tabZak.Rows.Count; ++i1)
                    {
                        this.cbZakaznik.Items.Add(((string)this.tabZak.Rows[i1]["prijmeni"]) + " " + ((string)this.tabZak.Rows[i1]["jmeno"]));
                    }
                }

                return true;
            }
            catch (Exception exc)
            {
                this.util.PisLog("Výdej " + iErrKod.ToString() + ": " +
                  exc.ToString(), true);

                return false;
            }
            finally
            {
                if (fbAda != null)
                    fbAda.Dispose();

                this.util.OdpojDb(fbCmd);
            }
        }

        private void chbFirma_CheckedChanged(object sender, EventArgs e)
        {
            NactiData();
        }

        private void btnPridej_Click(object sender, EventArgs e)
        {
            pocet += 1;
            int i1;
            xz = this.cbZbozi0.Location.X;
            yz = this.cbZbozi0.Location.Y;
            this.comboBox = new System.Windows.Forms.ComboBox();
            this.comboBox.Location = new System.Drawing.Point(xz , yz + (mezera * this.pocet));
            this.comboBox.Size = new System.Drawing.Size(this.cbZbozi0.Size.Width, this.cbZbozi0.Size.Height);
            for (i1 = 0; i1 < this.tabZbo.Rows.Count; ++i1)
            {
                this.comboBox.Items.Add((string)this.tabZbo.Rows[i1]["nazev"]);
            }
            this.comboBox.Name = "cbZbozi" + pocet.ToString();
            this.comboBox.SelectionChangeCommitted += new EventHandler(this.combobox_SelectionChangeCommitted);
            this.Controls.Add(this.comboBox);

            xm = this.nuMnozstvi0.Location.X;
            ym = this.nuMnozstvi0.Location.Y;
            this.numericUpDown = new System.Windows.Forms.NumericUpDown();
            this.numericUpDown.Location = new System.Drawing.Point(xm, ym + (mezera * this.pocet));
            this.numericUpDown.Size = new System.Drawing.Size(this.nuMnozstvi0.Size.Width, this.nuMnozstvi0.Size.Height);
            this.numericUpDown.ValueChanged += new EventHandler(this.numericUpDown_Zmena);
            this.numericUpDown.Name = "nuMnozstvi" + pocet.ToString();
            this.Controls.Add(this.numericUpDown);

            xc = this.tbCena0.Location.X;
            yc = this.tbCena0.Location.Y;
            this.textBox = new System.Windows.Forms.TextBox();
            this.textBox.Location = new System.Drawing.Point(xc, yc + (mezera * this.pocet));
            this.textBox.Size = new System.Drawing.Size(this.tbCena0.Size.Width, this.tbCena0.Size.Height);
            this.textBox.Name = "tbCena" + pocet.ToString();
            this.Controls.Add(this.textBox);

            xp = this.btnPridej.Location.X;
            yp = this.btnPridej.Location.Y;
            this.btnPridej.Location = new Point(xp, yp + mezera );

            this.button = new System.Windows.Forms.Button();
            this.button.Location = new System.Drawing.Point(xp - 80, yp + mezera);
            this.button.Size = new System.Drawing.Size(this.btnPridej.Size.Width, this.btnPridej.Size.Height);
            this.button.Click += new EventHandler(this.btnZrusit_Click);
            this.button.BackColor = Color.LightGray;
            this.button.Text = "Zrušit";
            this.button.Name = "btnZrusit" + pocet.ToString();
            this.Controls.Add(this.button);

            xo = this.btnOK.Location.X;
            yo = this.btnOK.Location.Y;
            this.btnOK.Location = new Point(xo, yo + mezera);

            xs = this.btnStorno.Location.X;
            ys = this.btnStorno.Location.Y;
            this.btnStorno.Location = new Point(xs, ys + mezera);

            xh = this.btnHistorie.Location.X;
            yh = this.btnHistorie.Location.Y;
            this.btnHistorie.Location = new Point(xh, yh + mezera);
        }

        private void cbZbozi_SelectionChangeCommitted(object sender, EventArgs e)
        {
            int index = this.cbZbozi0.SelectedIndex;
            this.tbCena0.Text = Convert.ToString(this.tabZbo.Rows[index]["cena"]);
        }

        private void combobox_SelectionChangeCommitted(object sender, EventArgs e)
        {
            ComboBox selectComboBox = (ComboBox)sender;
            int index = selectComboBox.SelectedIndex;
            this.textBox.Text = Convert.ToString(this.tabZbo.Rows[index]["cena"]);
        }

        private void nuMnozstvi_Zmena(object sender, EventArgs e)
        {
            if (this.cbZbozi0.Text == "")
            {
                this.util.PisLog("Není vložené zboží.", true);
                return;
            }
            int indexZbozi = this.cbZbozi0.SelectedIndex;
            int mnozstvi = (int)this.tabZbo.Rows[indexZbozi]["mnozstvi"];
            if ((Convert.ToInt32(this.nuMnozstvi0.Text)) > mnozstvi)
            {
                this.util.PisLog("Vložené množství je větší něž skladové množství.", true);
                return;
            }
        }

        private void numericUpDown_Zmena(object sender, EventArgs e)
        {
            NumericUpDown selectNumericUpDown = (NumericUpDown)sender;
            string cislo = Convert.ToString(selectNumericUpDown.Name[10]);
            int cPocet = Convert.ToInt32(cislo);
            string zbozi = (string)this.Controls["cbZbozi" + cPocet].Text.Trim();
            if (zbozi == "")
            {
                this.util.PisLog("Není vložené zboží.", true);
                return;
            }
            string expression = "nazev = '" + zbozi + "'";
            DataRow[] foundRows;
            foundRows = this.tabZbo.Select(expression);
            int mnozstvi = Convert.ToInt32(foundRows[0][4]);
            string nuMnozstvi = this.Controls["nuMnozstvi" + cPocet].Text.Trim();
            if ((Convert.ToInt32(nuMnozstvi)) > mnozstvi)
            {
                this.util.PisLog("Vložené množství je větší něž skladové množství.", true);
                return;
            }
        }

        private void btnZrusit_Click(object sender, EventArgs e)
        {
            Button selectButton = (Button)sender;
            string cislo = Convert.ToString(selectButton.Name[9]);
            int cPocet = Convert.ToInt32(cislo);

            if (cPocet != this.pocet)
            {
                while (cPocet < this.pocet)
                {
                    int next = cPocet + 1;
                    this.Controls["tbCena" + cPocet].Text = this.Controls["tbCena" + next].Text.Trim();
                    this.Controls["nuMnozstvi" + cPocet].Text = this.Controls["nuMnozstvi" + next].Text.Trim();
                    this.Controls["cbZbozi" + cPocet].Text = this.Controls["cbZbozi" + next].Text.Trim();
                    cPocet++;
                }
            }

            this.Controls["tbCena" + this.pocet].Dispose();
            this.Controls["nuMnozstvi" + this.pocet].Dispose();
            this.Controls["cbZbozi" + this.pocet].Dispose();
            this.Controls["btnZrusit" + this.pocet].Dispose();
            xp = this.btnPridej.Location.X;
            yp = this.btnPridej.Location.Y;
            xo = this.btnOK.Location.X;
            yo = this.btnOK.Location.Y;
            xs = this.btnStorno.Location.X;
            ys = this.btnStorno.Location.Y;
            xh = this.btnHistorie.Location.X;
            yh = this.btnHistorie.Location.Y;

            this.button.Location = new Point(xp - 80, yp - mezera);
            this.btnPridej.Location = new Point(xp, yp - mezera);
            this.btnOK.Location = new Point(xo, yo - mezera);
            this.btnStorno.Location = new Point(xs, ys - mezera);
            this.btnHistorie.Location = new Point(xh, yh - mezera);
            this.pocet -= 1;
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            this.UlozData();
        }

        private void btnHistorie_Click(object sender, EventArgs e)
        {
            VydejHistorie vydejHistorie = new VydejHistorie(util);
            vydejHistorie.ShowDialog();
        }

        private bool UlozData()
        {
            int iErrKod = 10100;
            string sErr;
            int i1;
            FbCommand fbCmd = null;

            try
            {
                iErrKod = 10101;
                if (this.cbZakaznik.Text == "")
                {
                    this.util.PisLog("Zákazník musí být zadán.", true);
                    this.cbZakaznik.Focus();
                    return false;
                }

                for (i1 = 0; i1 <= pocet; ++i1)
                {
                    if (this.Controls["cbZbozi" + i1].Text == "")
                    {
                        this.util.PisLog("zboží musí být zadáno.", true);
                        this.Controls["cbZbozi" + i1].Focus();
                        return false;
                    }

                    if (this.Controls["nuMnozstvi" + i1].Text == "")
                    {
                        this.util.PisLog("množství musí být zadáno.", true);
                        this.Controls["nuMnozstvi" + i1].Focus();
                        return false;
                    }

                    iErrKod = 10102;
                    if (!this.util.PripojDb(out fbCmd, out sErr))
                    {
                        iErrKod = 10103;
                        this.util.PisLog("Příjem " + iErrKod.ToString() + ": " + sErr,
                          true);
                        return false;
                    }

                    foreach (DataRow row in this.tabZbo.Rows)
                    {
                        if (row["nazev"].ToString() == this.Controls["cbZbozi" + i1].Text.Trim())
                            index = i;
                        i += 1;
                    }
                    mnozstviSkladem = Convert.ToInt32(this.tabZbo.Rows[index]["mnozstvi"]);

                    fbCmd.CommandText = "update tzbozi set MNOZSTVI = @mnozstvi, KDOZMENIL = @kdozmenil where NAZEV = @nazev";
                    fbCmd.Parameters.Add("@mnozstvi", FbDbType.Integer).Value = this.mnozstviSkladem - Convert.ToInt32(this.Controls["nuMnozstvi" + i1].Text.Trim());
                    fbCmd.Parameters.Add("@kdozmenil", FbDbType.VarChar, 200).Value = this.util.KdoZmenil;
                    fbCmd.Parameters.Add("@nazev", FbDbType.VarChar, 100).Value = this.Controls["cbZbozi" + i1].Text.Trim();
                    fbCmd.ExecuteNonQuery();
                    fbCmd.Transaction.Commit();
                    fbCmd.CommandText = "";
                    fbCmd.Parameters.Clear();
                    fbCmd = null;
                    vydej += vydej = "Zboží: " + this.Controls["cbZbozi" + i1].Text.Trim() + " Množství: " + this.Controls["nuMnozstvi" + i1].Text.Trim() +
                            " Cena: " + this.Controls["tbCena" + i1].Text.Trim() + " | ";
                    this.mnozstviSkladem = 0;
                    this.i = 0;
                }

                iErrKod = 10200;
                if (!this.util.PripojDb(out fbCmd, out sErr))
                {
                    iErrKod = 10201;
                    this.util.PisLog("Výdej " + iErrKod.ToString() + ": " + sErr,
                      true);
                    return false;
                }

                fbCmd.CommandText = "insert into tvydej (ZAKAZNIK, VYDEJ, KDOZMENIL) values (@ZAKAZNIK, @VYDEJ, @KDOZMENIL)";
                fbCmd.Parameters.Add("@zakaznik", FbDbType.VarChar, 30).Value = this.cbZakaznik.Text.Trim();
                fbCmd.Parameters.Add("@kdozmenil", FbDbType.VarChar, 200).Value = this.util.KdoZmenil;
                fbCmd.Parameters.Add("@vydej", FbDbType.VarChar, 1000).Value = this.vydej;
                fbCmd.ExecuteNonQuery();
                fbCmd.Transaction.Commit();

                this.Obnov();
                NactiData();
                return true;
            }
            catch (Exception exc)
            {
                this.util.PisLog("Výdej " + iErrKod.ToString() + ". " +
                  exc.ToString(), true);
                return false;
            }
            finally
            {
                this.util.OdpojDb(fbCmd);
            }
        }

        private void Obnov()
        {
            int i1;
            for (i1 = 1; i1 <= pocet; ++i1)
            {
                this.Controls["tbCena" + i1].Dispose();
                this.Controls["nuMnozstvi" + i1].Dispose();
                this.Controls["cbZbozi" + i1].Dispose();
                this.Controls["btnZrusit" + i1].Dispose();
            }       
            this.btnOK.Location = new Point(29, 110);
            this.btnStorno.Location = new Point(121, 110);
            this.btnHistorie.Location = new Point(212, 110);
            this.btnPridej.Location = new Point(606, 61);
            this.cbZakaznik.Text = "";
            this.cbZbozi0.Text = "";
            this.nuMnozstvi0.ResetText();
            this.tbCena0.Text = "";
            this.pocet = 0;
            this.vydej = "";
        }

        private void btnStorno_Click(object sender, EventArgs e)
        {
            Obnov();
            NactiData();
        }
    }
}
